// Prova per un blocco

import general.Tracer;
import analyzer.record.ARecordOnLine;

import com.lauterbach.trace32.api.Trace32Exception;

public class ProvaBlock {

	
	public static long ComputeBlock(int start_addr, int end_addr) throws Trace32Exception{
		
		long start_timestamp;
		long end_timestamp;
		long tempo_click;
		double tempo_ns, tempo_ms;
		
		Tracer.t32.stepMode(2);
		
		//prima cancello tutti i breakpoint
		Tracer.t32.command("break.delete /ALL");
		// setto il break sull'indirizzo di partenza
		Tracer.t32.command("break.set 0x"+Integer.toHexString(start_addr));
		//	metto il break all'arrivo
		Tracer.t32.command("break.set 0x"+Integer.toHexString(end_addr));
		
		//e faccio partire
		Tracer.t32.go();
		
		
		
		Tracer.t32.Step();
		//prendo il primo record (corrispondente a quello di partenza)
		ARecordOnLine rec_start=new ARecordOnLine(-1);
		//ora posso cancellare il trace buffer
		Tracer.t32.command("trace.reset");
		// mi segno il timestamp di partenza
		start_timestamp=rec_start.getTimestamp();
		
		//cancello il break di partenza
		Tracer.t32.command("break.delete 0x"+Integer.toHexString(start_addr));
		//metto il break all'arrivo
		//Tracer.t32.command("break.set 0x"+Integer.toHexString(end_addr));
		//e parto...
		Tracer.t32.go();
		
		Tracer.t32.Step();
		//	prendo il primo record (corrispondente a quello di arrivo)
		ARecordOnLine rec_end=new ARecordOnLine(-1);
		//ora posso cancellare il trace buffer
		Tracer.t32.command("trace.reset");
		// mi segno il timestamp di partenza
		end_timestamp=rec_end.getTimestamp();
		tempo_click=end_timestamp-start_timestamp;
		tempo_ns=(tempo_click/256)*20;
		tempo_ms=(tempo_ns)/1000;
		System.out.println("=======================================================");
		System.out.print("Block START addr: 0x"+Integer.toHexString(start_addr));
		System.out.println(" (line n."+Tracer.t32.getSourceLine(start_addr)+" in source file)");
		System.out.print("Block END addr: 0x"+Integer.toHexString(end_addr));
		System.out.println(" (line n."+Tracer.t32.getSourceLine(end_addr)+" in source file)" );
		System.out.println("COMPUTATION TIME: "+tempo_click+" click = "+tempo_ns+"ns =" +tempo_ms+"us. ********* ");
		System.out.println("=======================================================");
		
		return tempo_click;
}




	/**
	 * @param args
	 * @throws Trace32Exception 
	 */
	public static void main(String[] args) throws Trace32Exception {
		
		//Trace32Breakpoint[] br=new Trace32Breakpoint[50];
		
		ComputeBlock(0x4E8,0x4F4);
		
		
		
		
		
	}

}
