import java.io.IOException;

import com.lauterbach.trace32.api.Trace32Exception;

import general.Tracer;
import block.codeblock.task.Task;
import cpu.nios2.analyzer.record.ARecord4NiosII;

public class ProvaORTI {

	/**
	 * @param args
	 * @throws Trace32Exception 
	 * @throws IOException 
	 */
	public static void main(String[] args) throws Trace32Exception, IOException {
	
		// inizializzo il tracer
		Tracer.init();
				
		// prendo il minimo e il max degli indici dei record nell'analyzer
		long max=Tracer.t32.AnaStatusMax(); //-1 (record piu' attuale, quello al quale si finisce)
		long min=Tracer.t32.AnaStatusMin(); // record piu' vecchio, quello dal quale si comincia)
		
		ARecord4NiosII r;
		
		// creo un nuovo task
		Task t=new Task(1,"main_task",0x00,0x2000);
		

		// ciclo per leggere tutti i record
		for(long num_record= min;num_record<=max;num_record++) {
			//System.out.println("Leggo record n."+num_record);
			r=new ARecord4NiosII(num_record);
			if ( (r.isDataAccessClass()) ) {
				
				if ( (r.getPAddress()>=0x200BFFC) && (r.getPAddress()<=0x200BFFF) )
					System.out.println("RECORD N. "+r.getNumRecord()+" ho letto la var ISR2_fired!!!");
				
					
			}
			
			
			
		}
	}

}
