// Prova per testare le liste ordinate

import general.utils.SortedList;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import com.lauterbach.trace32.api.Trace32Exception;

import cpu.nios2.Nios2CPU;
import cpu.nios2.analyzer.record.ARecord4NiosII;

import block.codeblock.set.CodeBlocks;

public class ProvaSortedList {
	
	public static void riempi_facile(int start_addr, int end_addr) throws Trace32Exception {
		final int MIN=-1200;
		final long MASK1=0x000000FF;
		final long MASK2=0x0000FFFF;
		final long MASK3=0x00FFFFFF;
		final long MASK4=0x00000000FFFFFFFF;
		
		
		
		SortedList lista=new SortedList(start_addr, end_addr);
		System.out.println("RIGA\tADDR\tOPCODE\tOFFSET\tDEST");
		for(int riga=MIN; riga<=-1;riga++) {
			
			ARecord4NiosII rec=(ARecord4NiosII) new ARecord4NiosII(riga);
			long curr_addr=rec.getPAddress();
			long curr_data=rec.getBusDatalong();
			int	 curr_len=rec.getBusWidth();
			long mask;
			switch (curr_len) {
			case 1: mask=MASK1;
			
			break;
			case 2: mask=MASK2;
			break;
			case 3: mask=MASK3;
			break;
			case 4: mask=MASK4;
			break;
			default:mask=MASK4;
			break;
			}
			// maschero per togliere via i byte non significativi
			long curr_instr=(int)curr_data & mask;
			// maschero per avere l'opcode
			int curr_opcode=(int) (curr_instr & Nios2CPU.MASK_OPCODE_JUMP);
			
			
			int imm16;
			// maschero i bit della destinazione
			imm16=(int) ((curr_instr & Nios2CPU.MASK_DEST_JUMP) >> 6);
			// li shifto a destra di 6 bit per averli allineati
			int curr_offset;
			if ((imm16 & 0x00008000)!=0)
				curr_offset=(imm16| 0xFFFF0000);
			else
				curr_offset=imm16;
			
			int curr_dest= (int) (curr_offset+ curr_addr+Nios2CPU.lengthInstr());
			if (rec.isProgramAccessClass()) {
				if ( Nios2CPU.isJump(curr_opcode) | Nios2CPU.isCondJump(curr_opcode) ) {
					System.out.print(riga+"\t"+Long.toHexString(curr_addr)+"\t"+curr_opcode+"\t");
					System.out.println(curr_offset+"\t"+Long.toHexString(curr_dest));
					lista.insert(curr_addr);
					lista.insert(curr_dest-1);
					lista.insert(curr_dest);
					lista.insert(curr_addr+1);
				}
			}
			
		}
		
		//lista.stampa();
		
	}
	
	public static void main(String[] args) throws IOException, Trace32Exception {
		SortedList lista= new SortedList(1000,1046);
		
		File f=new File("C:\\fake_jumps.txt");
		BufferedReader in=new BufferedReader(new FileReader(f));
		
		String line="";
		
		
		// leggo le linee di codice
		for(int j=1;j<=43;j++) {
			line=in.readLine();
			// prendo i vari campi
			String[] data=line.split("\t");
			int indirizzo=Integer.parseInt(data[0]);
			String opcode=data[1];
			int dest=Integer.parseInt(data[2]);
			
			if ( (opcode.compareTo("jump")==0) | (opcode.compareTo("jmpc")==0) )  {
				if (opcode.compareTo("jump")==0) {
					lista.insert(indirizzo);
					lista.insert(dest-1);
					lista.insert(dest);	// inserisci la destinazione
					lista.insert(indirizzo+1);
					
				}
				if (opcode.compareTo("jmpc")==0) {
					
					lista.insert(indirizzo);
					lista.insert(dest-1);
					lista.insert(dest);
					lista.insert(indirizzo+1); // inserisci anche l'indirizzo successivo
					
				}
			}// if grande
		}// for
		lista.stampa();
		System.err.println("PARTO DA QUI!");
		
		CodeBlocks c=new CodeBlocks();
		c.printReport();
		riempi_facile(0x858,0x960);
	}
}	
