import java.io.*;

import com.lauterbach.trace32.api.Trace32Exception;

import block.codeblock.BlockCode;
import block.codeblock.set.Tasks;
import block.codeblock.task.Task;
import block.datablock.BlockData;
import analyzer.record.ARecordOnLine;

public class ProvaTasks {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws IOException 
	 * @throws IOException 
	 * @throws Trace32Exception 
	 */
	
	public static void aggiungi(Tasks t) throws IOException, Trace32Exception {
		
		// creo i task
		Task t0=new Task(1,"task1",1000,1999);
		Task t1=new Task(2,"task2",2000,2999);
		Task t2=new Task(3,"task3",3000,3999);
		
		// aggiungo i blocchi
		BlockCode b01=new BlockCode(1000,1100);
		t0.addCalledFunction(b01);
		BlockCode b02=new BlockCode(1101,1200);
		t0.addCalledFunction(b02);
		
		BlockCode b11=new BlockCode(2000,2100);
		t1.addCalledFunction(b11);
		BlockCode b12=new BlockCode(2101,2200);
		t1.addCalledFunction(b12);
		BlockCode b13=new BlockCode(2201,2300);
		t1.addCalledFunction(b13);
		
		BlockData b=new BlockData(2500,2510);
		t1.addDataBlock(b);
		b=new BlockData(2520,2520);
		t1.addDataBlock(b);
		
		BlockCode b21=new BlockCode(3000,3100);
		t2.addCalledFunction(b21);
		BlockCode b22=new BlockCode(3101,3200);
		t2.addCalledFunction(b22);
		
		
		
		
		
		// li aggiungo
		t.add(t0);
		t.add(t1);
		t.add(t2);
		
		
		
	}
	public static void main(String[] args) throws IOException, Trace32Exception  {
		
		Tasks t=new Tasks();
		
		
		aggiungi(t);
		File f = new File("c:\\fake_track.txt");
		BufferedReader in= new BufferedReader(new FileReader( f));
		String line= in.readLine();
		long last_tempo=0;
		while (line !=null) {
			
			String[] data= line.split("\t");
			String acc=data[0];
			int add=Integer.parseInt(data[1]);
			//String istr=data[2];
			long tempo=Long.parseLong(data[3]);
			long exec=tempo-last_tempo;
			
			ARecordOnLine r= new ARecordOnLine();
			r.setPaddress((long) add);
			r.setTimestamp(tempo);
			r.setTime_exec(exec);
			if (acc.compareTo("data")==0)
				r.setAccess_class((byte) 1);
			else
				r.setAccess_class((byte) 0);
			
			t.leggiRecord(r);
			
			line=in.readLine();
			last_tempo=tempo;
		}
		
		in.close();
		t.printReport();
	    }


}
