//commentata

package block.codeblock.set;


import general.Tracer;
import general.utils.SortedList;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import com.lauterbach.trace32.api.Trace32Exception;

import cpu.nios2.Nios2CPU;
import cpu.nios2.analyzer.record.ARecord4NiosII;

import analyzer.record.ARecord;
import block.Block;
import block.codeblock.BlockCode;



/**Rappresenta un insieme di blocchi da monitorare
 * @author Pierfrancesco
 *
 */
/**
 * @author Pierfrancesco
 *
 */
public class CodeBlocks extends SetOfPieceOfCode{
	
	
	private class Destinazioni {
		
		public long dest1;
		public Block link1;
		public long dest2;
		public Block link2;
		
		
		
		public Destinazioni() {
			super();
			this.dest1 = 0;
			this.link1 = null;
			this.dest2 = 0;
			this.link2 = null;
		}
		/**
		 * @return Returns the dest1.
		 */
		public long getDest1() {
			return dest1;
		}
		/**
		 * @param curr_dest The dest1 to set.
		 */
		public void setDest1(long curr_dest) {
			this.dest1 = curr_dest;
		}
		/**
		 * @return Returns the dest2.
		 */
		public long getDest2() {
			return dest2;
		}
		/**
		 * @param dest2 The dest2 to set.
		 */
		public void setDest2(long dest2) {
			this.dest2 = dest2;
		}
		/**
		 * @return Returns the link1.
		 */
		public Block getLink1() {
			return link1;
		}
		/**
		 * @param link1 The link1 to set.
		 */
		public void setLink1(Block link1) {
			this.link1 = link1;
		}
		/**
		 * @return Returns the link2.
		 */
		public Block getLink2() {
			return link2;
		}
		/**
		 * @param link2 The link2 to set.
		 */
		public void setLink2(Block link2) {
			this.link2 = link2;
		}
		
		
	} // class Destinazioni
	
	
	private HashMap	dest;
	private SortedList lista_jump;
	private SortedList lista_blocchi;
	
	/** Costruttore di default
	 *
	 */
	
	public CodeBlocks()  {
		super();
		this.dest= new HashMap();

	}
	
	
	/** Estrae dal file ELF le info per creare i vari blocchi
	 * 
	 *  ATTENZIONE! E' ancora molto inefficiente
	 *  Bisogna studiare una versione piu' performante
	 * @throws IOException 
	 * @throws Trace32Exception 
	 * @throws Trace32Exception 
	 */
	/*public void riempi(long start_addr, long end_addr) throws IOException, Trace32Exception  {
		
		long inizio_blocco=0;
		long fine_blocco=0;
		boolean blocco=true;
		
		// trovo il file ELF corrispondente all'indirizzo...
		String nomefile="";
		try {
			nomefile = trovaNomeFileELF(start_addr);
		} catch (Trace32Exception e) {
			e.printStackTrace();
		}
		
		// ...e lo apro
		FileELF4Nios2 file_elf=new FileELF4Nios2(nomefile, start_addr, end_addr);
		file_elf.open();
		// ciclo per leggere dal file ELF
		do {
			
			// leggo un elemento dal file ELF
			//leggiELF(file_elf.getCurr_addr(), file_ELF);
			file_elf.read();
			
			// se sono all'inizio di un blocco
			if (blocco==true) {
				blocco=false;
				inizio_blocco=file_elf.getCurr_addr();
			}
			if ( file_elf.isCurrJump() | file_elf.isCurrCondJump() )  {
				fine_blocco=file_elf.getCurr_addr();
				// creo il blocco				
				BlockCode b=new BlockCode("BLOCK_"+Long.toString(inizio_blocco), inizio_blocco, fine_blocco);
				
				blocco=true;
				//b.setDest1(file_elf.getCurr_dest()); // se jump incondizionato solo questo
				if (Nios2CPU.isCondJump(file_elf.getCurr_opcode())) { // se jump condizionato
					//b.setDest2((file_elf.getCurr_addr()+Nios2CPU.lengthInstr())); // anche il blocco successivo
				} 
				// aggiungo il blocco alla lista
				this.vettore.add(b);
				
				inizio_blocco=0;
				fine_blocco=0;
			}//if
		} while (!file_elf.isEnd());// ciclo per leggere dal file ELF
		
		// chiudo il file
		file_elf.close();
		
		//	questo per l'ultimo blocco
		if (blocco==false) {
			fine_blocco=file_elf.getCurr_addr();
			BlockCode b=new BlockCode("BLOCK_"+Long.toString(inizio_blocco), inizio_blocco, fine_blocco);
			// aggiungo il blocco alla lista
			this.vettore.add(b);
		}//if
		
		// analizzo tutti i blocchi per collegarli tra loro
		for(int i=0;i<this.vettore.size();i++) {
			//BlockCode corrente= (BlockCode) this.vettore.get(i);
			for(int j=0;j<this.vettore.size();j++) {
				//BlockCode iter=(BlockCode) this.vettore.get(j);
				//long salto1=corrente.getDest1();
				//long salto2=corrente.getDest2();
				
				if ( (salto1>=iter.getStart_address()) && (salto1<=iter.getEnd_address())  ) {
					if (salto1!=iter.getStart_address()) {// allora divido i salti
						BlockCode b_dopo=new BlockCode("BLOCK_"+salto1, salto1, iter.getEnd_address());
						iter.setEnd_address(salto1-Nios2CPU.lengthInstr());
						b_dopo.setDest1(iter.getDest1());
						b_dopo.setDest2(iter.getDest2());
						b_dopo.setLink1(iter.getLink1());
						b_dopo.setLink2(iter.getLink2());
						iter.setDest1(salto1);
						iter.setLink1(b_dopo);
						iter.setDest2(0);
						iter.setLink2(null);
						this.vettore.add(j+1,b_dopo);
						corrente.setLink1(b_dopo);
					}
					else  
						corrente.setLink1(iter);
				}//if
				
				if ( (salto2>=iter.getStart_address()) && (salto2<=iter.getEnd_address())  ) {
					if (salto2!=iter.getStart_address()) {// allora divido i salti
						BlockCode b_dopo=new BlockCode("BLOCK_"+salto2, salto2, iter.getEnd_address());
						b_dopo.setDest1(iter.getDest1());
						b_dopo.setDest2(iter.getDest2());
						b_dopo.setLink1(iter.getLink1());
						b_dopo.setLink2(iter.getLink2());
						iter.setEnd_address(salto2-Nios2CPU.lengthInstr());
						iter.setDest2(salto1);
						iter.setLink2(b_dopo);
						iter.setDest1(0);
						iter.setLink1(null);
						
						this.vettore.add(j+1,b_dopo);
						corrente.setLink2(b_dopo);
					}
					else  
						corrente.setLink2(iter);
				}//if
				
				
			}// for j
		}//for i
		
	}
	*/
	private void ins(long n, SortedList lblocchi, SortedList ljump) {
		long num=n;
		while (ljump.isIn(num)) 
			num -= Nios2CPU.lengthInstr();
		lblocchi.insert(num);
		num=n;
		while (ljump.isIn(num)) 
			num += Nios2CPU.lengthInstr();
		lblocchi.insert(num);
		
	}

	/** Estrae dalla traccia info per allocare i blocchi
	 *  
	 * @param start_addr
	 * @param end_addr
	 * @throws Trace32Exception
	 * @throws IOException 
	 */
	public void analizza(long start_addr, long end_addr) throws Trace32Exception, IOException {
		final long MIN=Tracer.t32.AnaStatusMin();
		String nome_file=Tracer.t32.getSourceFile(start_addr);
		lista_blocchi = new SortedList(start_addr, end_addr);
		lista_jump = new SortedList(start_addr-1, end_addr+1);
		for(long riga=MIN; riga<=-1;riga++) {
			
			ARecord4NiosII rec=(ARecord4NiosII) new ARecord4NiosII(riga);
			
			long curr_addr=rec.getPAddress();
			if (rec.isProgramAccessClass()) {
				
				// se e' un jump
				
				if (( rec.isJump() | rec.isCondJump() ) & (rec.isProgramAccessClass())) {
					if (lista_blocchi.isIn(curr_addr)) // se e' presente nella lista dei blocchi
						lista_blocchi.remove(curr_addr);	// lo rimuovo!
					
					lista_jump.insert(curr_addr);
					
					ins(curr_addr,lista_blocchi, lista_jump);
					lista_blocchi.remove(curr_addr);
					
					
					// inserisco anche i destinatari
					long curr_dest=rec.getDestJump();
					//ins(curr_dest,lista_blocchi, lista_jump);
					
					
					// metto nella tabella dei destinatari
					// i destinatari dei jumps
					Long curr_addr_obj=new Long(curr_addr);
					// creo l'elemento delle destinazioni
					Destinazioni dest_obj=new Destinazioni();
					dest_obj.setDest1( curr_dest);
					if (rec.isCondJump()) {
						dest_obj.setDest2((curr_addr+Nios2CPU.lengthInstr()));
						//ins(curr_dest, lista_blocchi, lista_jump);
					}
					this.dest.put(curr_addr_obj,dest_obj);
				} //if
				
			}// if esterno
		}//for
		// adesso faccio un ciclo finche' non tolgo tutti i jump
		boolean modificato=true;
		while (modificato) {
			modificato=false;
			
			for(int i=0;i<lista_jump.size();i++) {
				Long curr_jump=(Long) lista_jump.get(i);
				if (lista_blocchi.isIn(curr_jump.longValue())) { // se c'e' nella lista
					lista_blocchi.remove(curr_jump.longValue()); // lo elimino
					if (!lista_jump.isIn(curr_jump.longValue()-Nios2CPU.lengthInstr()))
						lista_blocchi.insert(curr_jump.longValue()-Nios2CPU.lengthInstr());
					if (!lista_jump.isIn(curr_jump.longValue()+Nios2CPU.lengthInstr()))
						lista_blocchi.insert(curr_jump.longValue()+Nios2CPU.lengthInstr());
					modificato=true;
				}//if esterno
			} //for	
		}//while 
		// adesso alloco i blocchi veri e propri
		for(int i=0;i<lista_blocchi.size()-1;i +=2) {
			Long ob=(Long) lista_blocchi.get(i);
			long addr1=ob.longValue();
			ob=(Long) lista_blocchi.get(i+1);
			long addr2=ob.longValue();
			BlockCode b=new BlockCode("BLOCK_"+addr1,nome_file, (int)addr1, (int)addr2);
			this.vettore.add(b);
		}
		
	} //method
	
	
	/*private String trovaNomeFileELF(long indirizzo_corr) throws Trace32Exception {
		
		final String	prefixELF="ELF";		// prefisso per un file ELF
		
		
		
		// cerco il nome del file corrispondente all'indirizzo iniziale
		String nomefile_temp=Tracer.t32.getSourceFile(indirizzo_corr);
		int indice_punto=nomefile_temp.lastIndexOf(".");
		// chiudo il collegamento con il tracer
		Tracer.t32.exit();
		return (nomefile_temp.substring(0,indice_punto+1)+prefixELF);
		
	}
	*/
		
	/** Scrive su file la descrizione per DOT dei blocchi in formato grafico
	 * @param file			file su cui scrivere
	 */
	public void dot(PrintWriter file) throws Trace32Exception {
		
		file.println("node [shape=box];");
		file.println("rankdir=TB;");
		for(int k=0;k<this.vettore.size();k++) {
			BlockCode b_stampa=(BlockCode) this.vettore.get(k);
			b_stampa.dot(file);
			// link tra blocco e rombo del jump
			file.print(b_stampa.getName()+" -> BLOCK_"+(b_stampa.getEnd_line()+Nios2CPU.lengthInstr()));
			file.println(" [headport=n , tailport=s ]"+" ;");
		}
		file.println("/* AGGIUNGO I COLLEGAMENTI DEI JUMP! */");
		// adesso stampo i blocchi dei jump
		for(int k=0;k<this.lista_jump.size();k++) {
			Long curr_j=(Long) this.lista_jump.get(k);
			file.println("BLOCK_"+curr_j.longValue()+ " [shape=diamond label=\""+(curr_j.longValue())+"_jump"+"\" ];");
			// link tra jump e blocco successivo (fittizio)
			file.print("BLOCK_"+curr_j.longValue()+ " -> BLOCK_"+(curr_j.longValue()+Nios2CPU.lengthInstr() )+ " [color=white , ");
			file.println("headport=w , tailport=s   ];");
			file.println(" { rank=same; \""+"BLOCK_"+curr_j.longValue()+"\" ; }");
			Destinazioni d=(Destinazioni) this.dest.get(curr_j);
			
			long d1=0;
			long d2=0;
			if (d!=null) {
				if (d.dest1!=0) {
					file.print("BLOCK_"+curr_j.longValue()+ " -> BLOCK_");
					for(int j=0;j<this.vettore.size();j++) {
						BlockCode b=(BlockCode) this.vettore.get(j);
						if (b.isInMyAddressSpace(d.dest1)) {
							d1=b.getStart_line();
							break;
						}
					}
					file.println(d1+" [headport=n , tailport=s ]; ");
				
				}
				if (d.dest2!=0) {
					file.print("BLOCK_"+curr_j.longValue()+ " -> BLOCK_");
					for(int j=0;j<this.vettore.size();j++) {
						BlockCode b=(BlockCode) this.vettore.get(j);
						if (b.isInMyAddressSpace(d.dest2)) {
							d2=b.getStart_line();
							break;
						}
					}
					file.println(d2+" [headport=n , tailport=s ]  ;");
				}
			}
			
		}
	
	}
	
	
	/** Legge un record permettendo che i blocchi da controllare siano innestati
	 * @param r				record da leggere
	 */
	/*public void leggiRecordSPECIAL(ARecord r) {

		int i=0;
		BlockCode t=null;
	
		// prendo l'indirizzo corrente del record passato al metodo
		long addr=r.getPAddress();
		
		
		// cerco a quale blocco si riferisce
		for(i=0;i<this.vettore.size();i++) {
			t=(BlockCode) this.vettore.get(i);
			if  ( (t.isInMyAddressSpace(addr)==true) )
				t.leggiRecord(r);
		}
		
	
	} // method
	*/
	
public void dtd(PrintWriter file) {
		
		file.println("<!ELEMENT CodeBlocks (CodeBlock)+");
		
		
	}
		
}	
	

