//commentata

/**
 * 
 */
package block.codeblock.set;

import java.io.PrintWriter;

import com.lauterbach.trace32.api.Trace32Exception;

import cpu.nios2.Nios2CPU;

import general.utils.Utils;
import analyzer.record.ARecord;
import block.Block;
import block.codeblock.BlockCode;
import block.set.SetOfPieces;

/**
 * @author Pierfrancesco
 *
 */
public  class SetOfPieceOfCode extends SetOfPieces{
	
	private long last_addr;
	
	/** Costruttore di default
	 * 
	 */
	public SetOfPieceOfCode() {
		super();
		this.last_addr=0;
		
	}
	
	/* (non-Javadoc)
	 * @see block.set.SetOfPieces#xml(int, java.io.PrintWriter)
	 */
	public void xml(int n, PrintWriter file) {
		String tab=Utils.tabs(n);
		file.println(tab+"<CODE_BLOCKS>");
		Block t=null;
		for(int i=0;i<this.vettore.size();i++) {
			t=(Block) this.vettore.get(i);
			t.xml(n+1, file);
		}
		file.println(tab+"</CODE_BLOCKS>");
	}
	
	public void dtd(PrintWriter file) {
		
		file.println("<!ELEMENT SetOfPieceOfCode (CodeBlock)+");
		
		
	}
	
	
	/* (non-Javadoc)
	 * @see block.set.SetOfPieces#leggiRecord(analyzer.record.ARecord)
	 */
	public void leggiRecord(ARecord r) {

		int i;
		BlockCode b=null;
		int max=this.vettore.size();
		long addr=r.getPAddress();
		for(i=0;i<max;i++) {
			b=(BlockCode) this.vettore.get(i);
			if ( (b.isInMyAddressSpace(addr)) || (b.isInteressato()) ) {
				this.last_addr=addr;
				b.leggiRecord(r);
				
			}
		}
		
			
	}
	
	
	
	/** Riempie i buchi tra un blocco e un altro
	 * @throws Trace32Exception 
	 * 
	 */
	public void fill() throws Trace32Exception {
		BlockCode p=null;
		if (this.vettore.size()>0) {
			p=(BlockCode) this.vettore.get(0);
			long indirizzo_iniziale=p.getStart_addr();
			if (indirizzo_iniziale>0) {	//piazzo un blocco iniziale
				BlockCode start_filler=new BlockCode(0,indirizzo_iniziale-Nios2CPU.lengthInstr());
				this.vettore.add(0,start_filler);
			}
			p=(BlockCode) this.vettore.lastElement();
			long indirizzo_finale=p.getEnd_addr();	// piazzo un blocco finale
			BlockCode end_filler=new BlockCode(indirizzo_finale+Nios2CPU.lengthInstr(), 0xfffffff);
			this.vettore.add(end_filler);
						
		}
		
/*		for(int indice=0;indice<(this.vettore.size()-1);indice++) { //scorro tutti i blocchi
			p=(BlockCode) this.vettore.get(indice);		//prendo l'i-esimo blocco
			BlockCode succ=(BlockCode) this.vettore.get(indice+1);
			if ((p.getEnd_addr()+Nios2CPU.lengthInstr()) < succ.getStart_addr()) { // se c'e' un buco
				//creo un nuovo blocco
				BlockCode nuovo=new BlockCode(p.getEnd_addr()+Nios2CPU.lengthInstr(),succ.getStart_addr()-Nios2CPU.lengthInstr());
				System.out.println("Ho inserito un blocco tra "+(p.getEnd_addr()+Nios2CPU.lengthInstr())+" e "+(succ.getStart_addr()-Nios2CPU.lengthInstr()));
				
				// e lo inserisco
				this.vettore.add(indice,nuovo);		
			}
		}*/
		
		
	}
	
	/** Riempie i buchi tra un blocco e un altro
	 * @param inizio		indirizzo di inizio
	 * @param fine			indirizzo di fine
	 * @throws Trace32Exception
	 */
	public void fill(long inizio, long fine) throws Trace32Exception {
		BlockCode p = null;
		if (this.vettore.size() > 0) {
			p = (BlockCode) this.vettore.get(0);
			long indirizzo_iniziale = p.getStart_addr();	//indirizzo del primo blocco
			if (indirizzo_iniziale > inizio) { // piazzo un blocco iniziale
				BlockCode start_filler = new BlockCode(inizio,
						indirizzo_iniziale - Nios2CPU.lengthInstr());
				this.vettore.add(0, start_filler);
			}
			p = (BlockCode) this.vettore.lastElement();
			long indirizzo_finale = p.getEnd_addr(); // fine dell'ultimo blocco
			if (indirizzo_finale<fine) {	//se l'ultimo blocco non raggiunge la fine
				BlockCode end_filler = new BlockCode(indirizzo_finale
						+ Nios2CPU.lengthInstr(), fine);
				this.vettore.add(end_filler);
			}
			
		}
		
	}	
	/** Legge un record di operazioni su dati 
	 * @param r
	 */
	public void leggiData(ARecord r) {
		int i;
		BlockCode b=null;
		int max=this.vettore.size();
		for(i=0;i<max;i++){
			b=(BlockCode) this.vettore.get(i);
			if ( (b.isInMyAddressSpace(this.last_addr)) || (b.isInteressato()) ) {
				 b.leggiData(r);
				 
			}
	
		}
	}
	
		

}
