//commentata

package block.codeblock.set;

import general.utils.Utils;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Hashtable;

import parsers.FindTasks;

import analyzer.record.ARecord;
import block.Block;
import block.codeblock.BlockCode;
import block.codeblock.task.Task;


/** Rappresenta un insieme di task da monitorare
 * @author Pierfrancesco
 *
 */
public class Tasks extends SetOfPieceOfCode{
	
		private Hashtable magic;		// contiene i magic (task in esecuzione, ecc ecc)
										// per il supporto ORTI/OSEK
	/** Costruttore di default
	 * 
	 */
	public Tasks() {
		super();
		magic = new Hashtable();
	}
	
	/** Scrive un file XML con le statistiche della traccia
	 * @param file			nome del file XML
	 */
	public void xml(int n, PrintWriter file) {

		String tab = Utils.tabs(n);
		file.println(tab+"<TASKS>");
		BlockCode t = null;
		for (int i = 0; i < this.vettore.size(); i++) {
			t = (BlockCode) this.vettore.get(i);
			t.xml(n+1, file);
		}
		file.println(tab+"</TASKS>");
	}
	
	public void dtd(String nomefile) throws IOException {
		//	 creo un file x il codice DTD
		File file_dtd=new File(nomefile);
		PrintWriter file_text=new PrintWriter(
				new BufferedWriter(
						new FileWriter(file_dtd,false)));
		
		// scrivo il tag iniziale del DTD
		file_text.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		file_text.println("<!ELEMENT Tasks (Task)+");
		// chiudo il file
		file_text.close();
		
	}

	/** Aggiunge un magic
	 * @param addr_magic		indirizzo del magic
	 * @param name				nome del magic
	 */
	public void addMagic(int addr_magic, String name) {
		Integer o=new Integer(addr_magic);
		// il nome e' la Key
		// l'oggetto e' l'indirizzo
		this.magic.put(name, o);
	}

	/** Cancella un magic
	 * @param name		nome del magic da cancellare
	 */
	public void delMagic(String name) {
		this.magic.remove(name);
				
	}
	
	public void leggiRecord(ARecord r){
		
		//leggo il magic per sapere il nome del task in esecuzione
		String running_task=(String) this.magic.get("running_task");
		int max=this.vettore.size();
		for (int i=0;i<max;i++){
			Task t=(Task) this.vettore.get(i);
			if (t.getName().compareTo(running_task)==0) { // se il nome coincide
				t.leggiRecord(r);
				break;
			}
		}
	}
	
	public void leggiData(ARecord r){
		//leggo il magic per sapere il nome del task in esecuzione
		String running_task=(String) this.magic.get("running_task");
		int max=this.vettore.size();
		for (int i=0;i<max;i++){
			Task t=(Task) this.vettore.get(i);
			if (t.getName().compareTo(running_task)==0) { // se il nome coincide
				t.leggiData(r);
				break;
			}
		}
		
		
	}
	
	public Task isTask(String name) {
		String compl_name=FindTasks.SUFFIX_TASK+name;
		int max=this.vettore.size();
		for(int i=0;i<max;i++) {
			Task t=(Task) this.vettore.get(i);
			if (compl_name.compareTo(t.getName())==0) 
				return t;
		}
		return null;
	}
	
}
