/**
 * 
 */
package block.datablock.set;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;

import com.lauterbach.trace32.api.Trace32Exception;

import general.Tracer;

import analyzer.record.ARecord;
import block.datablock.MagicData;
/** Rappresenta un insieme di oggetti data 
 * 	per monitorare le variabili globali ORTI
 * @author Pierfrancesco
 *
 */
public class SetMagicData extends SetOfPieceOfData {

	private HashMap cache;		// cache per gli indirizzi piu' frequenti
	
	/** Costruttore di default
	 * @throws Trace32Exception 
	 * @throws IOException 
	 * 
	 */
	public SetMagicData() throws IOException, Trace32Exception {
		// chiama il costruttore della superclasse
		super();
		this.cache=new HashMap();
		init("c:\\simboli.txt");
	}
	
	/* (non-Javadoc)
	 * @see block.set.SetOfPieces#add(block.Block)
	 */
	public void add(MagicData b) { this.vettore.add(b);	
		
	}
	
	
	/** Restituisce un blocco di cui si ha un indirizzo
	 * @param address
	 * @return
	 */
	public MagicData get(long address) {
		MagicData b=null; 
		for(int i=0;i<this.vettore.size();i++) {
			b= (MagicData) this.vettore.get(i);
			if ( (address>=b.getStart_line()) && (address<=b.getEnd_line()) ) 
				break;
		}
		// per velocizzare la cosa
		if (b!=null) {
			Long addr=new Long(address);
			this.cache.put(addr, b);
			
		}
		return b;
	}

		
	public void put(String name, String nome_file, long start, long end ) throws Trace32Exception {
		MagicData m=new MagicData(name, nome_file, start, end);
		add(m);
		
		this.cache.put(name, m);
		
		
		
	}
	
	public void put(MagicData m) {
		add(m);
		this.cache.put(m.getName(), m);
		
	}
	
	private void init(String filename) throws IOException, Trace32Exception {
		File f = new File(filename);
		BufferedReader symbols = new BufferedReader(new FileReader(f));
		String line=symbols.readLine();
		while (line!=null) {
			
			String[] data=line.split("\t");
			String symbol_name=data[0];
			long address=Tracer.t32.getSymbolAddress(symbol_name);
			int len=Integer.parseInt(data[2]);
			
			
			this.put(symbol_name, filename, address, (address+len));
			line=symbols.readLine();
			
		} 
		symbols.close();
		
	}
	
	public void leggiRecord(ARecord r) {
	
		super.leggiRecord(r);
				
		
	}

	public void dtd(PrintWriter file) {
		// TODO Auto-generated method stub
		
	}
	
}
