package com.lauterbach.trace32.api;

/**  
 * @author oli
 * 
 * Test program for Trace32API class.
 * 
 * The program is designed to be used with the Starcore simulator demo supplied
 * by Matthias Zens. It opens some T32 windows so you can single step the demo 
 * and see the effects in T32. 
 */
public class BasicTest {
	
	static Trace32API t32;
			
	public static void main(String[] args) {

		try {
			
			System.out.println("This is a rudimentary demo application for T32 JAPI.");
			
			t32 = Trace32API.getTrace32API(20000);
									
			/*
			 * Open the "area" window for showing text messages and checking
			 * commands.
			 */
			t32.command("area");
			t32.command("print \"Hello, T32!\"");

			/* Do "something" to show it works */
			t32.command("cd C:/");
			t32.command("ls");  // unix-style "ls" command will open window
						
			t32.exit();
			
		} catch (Trace32Exception e) {
			// Did you configure the config.t32 startup file for JAPI?
			System.out.println(e);
		}

	}
	
	
}

