/*
 * Created on 21.07.2003 by DIE
 *
 * (c) Lauterbach Datentechnik GmbH, Hofolding
 */
 
package com.lauterbach.trace32.api;

/**
 * @author Rudi Dienstbeck
 *
 */
public class Trace32Exception extends Exception
{
	private static class Cause extends Throwable {
		String description;
		public Cause (String d){
			description = d;
		}
	};
	public static final Cause NORESPONSE  = new Cause ("TRACE32 not responding");
	public static final Cause UNKNOWNHOST = new Cause ("Host not found");
	public static final Cause SOCKET      = new Cause ("Socket Exception");
	public static final Cause IO          = new Cause ("IO Exception");
	public static final Cause RECEIVE     = new Cause ("Receive failed");
	public static final Cause SYNC        = new Cause ("Sync failed");
	public static final Cause ACCESS      = new Cause ("Access refused");
	public static final Cause PARAMETER   = new Cause ("Invalid parameter");
	public static final Cause OTHER       = new Cause ("Exception");
	public static final Cause PRACTICEERR = new Cause ("PRACTICE Error");
	
	private Cause cause;
	
	Trace32Exception (Cause c) {
		super (c.description);
		cause = c;
	}

	Trace32Exception (Cause c, String s) {
		super (c.description + ": " + s);
		cause = c;
	}
	
	public Throwable getCause () {
		return cause;
	}
}
