package general;
import analyzer.record.ARecord;

import com.lauterbach.trace32.api.Trace32API;
import com.lauterbach.trace32.api.Trace32Exception;

import cpu.nios2.analyzer.record.ARecord4NiosII;

/** Rappresenta un'astrazione del tracer
 * @author Pierfrancesco
 * commentata
 */
public class Tracer {
	
	public static Trace32API t32;
	public static long lastTimestamp=0;
	static int port=10000;
	
	
	
	
	/** Costruttore per inizializzare il tracer HW
	 * @throws Trace32Exception
	 */
	public static void init() throws Trace32Exception {
		t32 = Trace32API.getTrace32API(port);
		long min=Tracer.t32.AnaStatusMin();
		ARecord primo=new ARecord4NiosII(min);
		lastTimestamp=primo.getTimestamp();
	}
	
	/** Costruttore per inizializzare il tracer alla porta specificata
	 * @param porta			porta sulla quale e' in ascolto il tracer
	 * @throws Trace32Exception
	 */
	public static void init(int porta) throws Trace32Exception {
		t32 = Trace32API.getTrace32API(porta);
		long min=Tracer.t32.AnaStatusMin();
		ARecord primo=new ARecord4NiosII(min);
		lastTimestamp=primo.getTimestamp();
	}
	
	
	public static void exit() throws Trace32Exception {
		t32.exit();
	}
	
}
