/**
 * 
 */
package general.utils;

import java.util.Vector;

/** Rappresenta una lista ordinata
 * @author Pierfrancesco
 *
 */
public class SortedList {
	
	private Vector 	vettore;
	private long start;
	private long end;
	
	/** Costruttore di dafault
	 * 
	 */
	public SortedList(long start, long end) {
		this.vettore=new Vector();
		Long s=new Long(start);
		Long e=new Long(end);
		this.vettore.add(s);
		this.vettore.add(e);
		this.start=start;
		this.end=end;
	}
	
	public void insert(long num) {

		if ((num>=this.start) && (num<=this.end)) {
			// creo l'elemento Object da inserire			
			Long ogg=new Long(num);
			int pos;
			Long curr=null;
			// cerco la posizione dove inserire
			for(pos=0;(pos<this.vettore.size()) ;pos++) {
				curr=(Long)this.vettore.get(pos);
				if (curr.longValue()>=num)
					break;
			}
			// inserisco l'elemento nella posizione
			// indicata da pos
			
			
			if (pos>=this.vettore.size())
				this.vettore.add(ogg);
			
			if (curr.longValue()!=num)
				this.vettore.add(pos,ogg);
		}
	}
	
	
	public void stampa() {
		
		for(int i=0;i<this.vettore.size()-1;i +=2) {
			Long ob=(Long) this.vettore.get(i);
			long v=ob.longValue();
			System.out.println("0x"+Long.toHexString(v));
			 ob=(Long) this.vettore.get(i+1);
			 v=ob.longValue();
			System.out.println("0x"+Long.toHexString(v));
			System.out.println("-----------");
		}
		
		
	}

	
	
	public int size() {
		return this.vettore.size();
		
	}
	
	public Object get(int i) {
		
		return this.vettore.get(i);
	}
	
	/** dice se un elemento e' presente nella lista
	 * @param num
	 * @return
	 */
	public boolean isIn(long num) {
		
		Long curr=null;
		// cerco la posizione dove inserire
		int pos=0;
		boolean trovato=false;
		for(pos=0;(pos<this.vettore.size()) ;pos++) {
			curr=(Long)this.vettore.get(pos);
			if (curr.longValue()==num) {
				trovato=true;
				break;
			}
		}
		
		return trovato;
		
		
	}
	
	
public boolean remove(long num) {
		
		/*Long curr=null;
		// cerco la posizione dove inserire
		int pos=0;
		boolean trovato=false;
		for(pos=0;pos<this.vettore.size() ;pos++) {
			curr=(Long)this.vettore.get(pos);
			if (curr.longValue()==num) {
				trovato=true;
				break;
			}
		}
		if (trovato) {
		if (pos==0)
			this.vettore.removeFirst();
		if (pos==this.vettore.size()-1)
			this.vettore.removeLast();
		if ( (pos>0) && (pos<this.vettore.size()))
			this.vettore.remove(pos);
		}
		return trovato;
		*/
		Long elem=new Long(num);
		return this.vettore.remove(elem);
	
		
	}
	
	
	public boolean isInBlock(long num){
		int pos=0;
		if ((num>=this.start) && (num<=this.end)) {
			// creo l'elemento Object da inserire			
			
			
			Long curr=null;
			// cerco la posizione dove inserire
			for(pos=0;(pos<this.vettore.size()) ;pos++) {
				curr=(Long)this.vettore.get(pos);
				if (curr.longValue()>num)
					break;
			}
			// inserisco l'elemento nella posizione
			// indicata da pos
			
		}
		if ((pos % 2)==0) // se e' pari
			return false;
		else
			return true; // se e' dispari
		
	}
	
	public long retStart(long num) {
		long risposta=0;
		int pos=0;
		if ((num>=this.start) && (num<=this.end)) {
			// creo l'elemento Object da inserire			
			Long curr=null;
			// cerco la posizione dove inserire
			for(pos=0;(pos<this.vettore.size()) ;pos++) {
				curr=(Long)this.vettore.get(pos);
				if (curr.longValue()>num)
					break;
			}
			// inserisco l'elemento nella posizione
			// indicata da pos
			
		}
		if (pos>0) {
				Long r=(Long) this.vettore.get(pos-1);
				risposta=r.longValue();
			} else risposta=0;
		return risposta;
		
		
	}
	
	
	
}
