// commentata

package parsers;

import java.io.File;
import java.io.IOException;
import java.util.Vector;

/** Elenca i files di una cartella ( e sottocartelle) con una certa estensione 
 * @author Pierfrancesco
 *
 */
public class ElencaFiles {
	
	private String path_project;
	private Vector list_files;
	
	/** Costruttore
	 * @param path					path della directory
	 * @throws IOException 
	 */
	public ElencaFiles(String path, String ext) throws IOException {
		
		this.path_project=path;
		this.list_files=new Vector();
		
		File dir = new File(this.path_project);
		
		if ( (!dir.exists()) || (!dir.isDirectory()) )  
			System.err.println("ERRORE: La directory non esiste!!!!");
		else {
			// lista tutti i files in una cartella con una certa estensione
			listDirectories(dir,this.list_files,ext);
			
		}
		
	}
	
	
	
	/** Lista tutti i files in una cartella con una certa estensione (ricorsivamente)
	 * @param dir				file che rappresenta la directory
	 * @param lista				lista in cui inserire i nomi dei files
	 * @param ext				estensione dei file (in minuscolo!)
	 * @throws IOException
	 */
	private  void listDirectories(File dir, Vector lista, String ext) throws IOException {
		
		File[] dirs = dir.listFiles();
		int max=dirs.length;
		
		for (int i=0;i<max;i++) {
			File f=dirs[i];
			if (!f.isDirectory()) { // se il file non e' una directory
				// se e' un sorgente C
				if (f.getName().toLowerCase().endsWith(ext)) {
					// devo mettere il nome nella  lista
					lista.add(f.getCanonicalPath());
					//DEBUG: provo a stampare il nome
					//System.out.println(f.getCanonicalFile());
				}
			}
			else { // se e' una directory
				listDirectories(f, lista, ext); // ricorsione
			}
		}
	}
	
	/**
	 * @return Returns the list_files.
	 */
	public Vector getListFiles() {
		return list_files;
	}
	
	
	
	
}
