/**
 * 
 */
package parsers;
//commentata


import general.Tracer;
import general.utils.Utils;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import com.lauterbach.trace32.api.Trace32Exception;

import block.codeblock.BlockCode;
import block.codeblock.task.Task;

import app.Application;

/** Trova le dichiarazioni di Task all'interno dei file .c non ancora preprocessati
 * @author Pierfrancesco
 *
 */
public class FindTasks {
	
	public final static String DECL_TASK="DeclareTask(";
	public final static String SUFFIX_TASK="Func";
	
	/** Costruttore
	 * 
	 */
	public FindTasks() {
		super();
	}


	/** Trova le dichiarazioni dei tasks nei sorgenti non ancora preprocessati
	 * @param filename				nome del file di cui fare il parsing
	 * @param app					riferimento all'applicazione
	 * @throws IOException
	 * @throws Trace32Exception 
	 */
	public int find(String filename, Application app) throws IOException, Trace32Exception  {
		
		File f = new File(filename);
		BufferedReader source = new BufferedReader(new FileReader(f));
		int count_line=0;
		int n_task=0;
		String name_task="";
		
		
		String line = source.readLine();
		count_line++;
		while (line != null){
			// controllo
			if ( line.indexOf(DECL_TASK)!=-1) {
				// ho trovato la dichiarazione del task
				name_task=SUFFIX_TASK+line.substring(line.indexOf("(")+1, line.indexOf(")"));
				// ho trovato un task
				n_task++;
				BlockCode t=app.getFunction(name_task);
				app.addTask(t);
				System.out.println("TASK "+name_task+" in file: "+filename+" line:"+count_line);
			}

			line = source.readLine();
			count_line++;
		}
		// chiudo il file
		source.close();
		return n_task;
		
	}
	
}
