//commentata

package parsers.cparser;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Stack;

public class MappaSezioniCritiche {
	
	private final String CRITICAL_REG_PREFIX="CriticalRegion_";
	
	private HashMap mappa;			// mappa per associare a una risorsa le sue regioni critiche
	private Stack stack;			//stack per contenere le regioni annidate
	
	
	// costruttore
	public MappaSezioniCritiche() {
		
		this.mappa=new HashMap();
		this.stack=new Stack();
	}
	
	
	
	
	
	public void printElements() {
		
		
		Enumeration enumeration = (Enumeration) this.mappa.keySet();
		
		while(enumeration.hasMoreElements()){
			System.out.println(enumeration.nextElement());
		}
	}
	
	
	public void addGetResource(int line, String resource_name) {
		Integer obj_int=new Integer(line);
		this.stack.push(obj_int);

	}
	
	public Blocco addReleaseResource(int line, String resource_name) {
		Integer obj_int=(Integer) this.stack.pop();
		if (obj_int==null) {
			System.err.println("ERRORE: non ho incontrato una GetResource() prima!!!");
			
		}
		int start_line=obj_int.intValue();
		int end_line=line;
		Blocco b=new Blocco();
		b.setNome(CRITICAL_REG_PREFIX+resource_name);
		b.setType(Blocco.CRITSECTION);
		b.setLinea_inizio( start_line);
		b.setLinea_fine( end_line);
		CriticalSections cr=(CriticalSections) this.mappa.get(resource_name);
		if (cr!=null) { // se esiste gia' una regione critica per quella risorsa
			cr.addCritialSection(b);
		} else { // se non esistono regioni critiche per quella risorsa
			cr=new CriticalSections();
			cr.addCritialSection(b);
		}
		return b;
	}
	
}
