package testcase;
//questo per il momento non serve al progetto
//non considerare ai fini della tesi



import general.Tracer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Vector;
import analyzer.record.ARecordOnLine;
import branch.BranchRecord;


import com.lauterbach.trace32.api.Trace32Exception;
import cpu.nios2.branch.BranchRecord4NiosII;

/**	Rappresenta un Test Case
 *	Prova tutte le condizioni di salto su un blocco di codice
 *	
 * @author Pierfrancesco
 *
 */
public class TestCase {
	
	private long start_address; 	// indirizzo di partenza
	private long end_address; 	// indirizzo di arrivo
	private int n_break;		// num di break settati
	private Vector brecord;		// contiene info sul break settati
	// E' un vettore di BranchRecord
	private Conditions condition;// condizioni che vanno settate ogni volta
	//private Trace32API t32;		// riferimento al tracer
	
	private TraceResult[] resu;	// risultati delle prove
	
	
	/** Esplora tra l'indirizzo di partenza e di fine
	 *  alla ricerca di branch condizionali
	 * @return			il numero di branch condizionali trovati
	 */
	private int exploreBreak() {
		// esplora tutti i break condizionali
		// che ci possono essere tra start_line e end_line
		
		// da una analisi statica del codice
		// ne restituisce il numero
		// e agisce anche sul Vector brecord
		// settandone gli elementi
		
		this.brecord.clear(); // cancello tutto
		int i=0;
		
		BranchRecord4NiosII br=new BranchRecord4NiosII((int) 0x8D0,(int) 0x1E,(byte)2, (byte)0,(byte)0,0);
		
		// aggiungo a mano il record in 0x8D0
		
		/*br.getAddress(0x8D0); // 0x8D0
		 br.rA=2;
		 br.rB=0;
		 br.yetexec=false;
		 
		 // questi sono vuoti
		  br.rC=0;
		  br.immediate=0;
		  br.setType(0x1E);*/
		this.brecord.add(br);
		i++;
		
		// aggiungo a mano il record in 0x908
		br=new BranchRecord4NiosII((int)0x908,(int)0x1E,(byte)2,(byte)0,(byte)0,(int)0);
		
		/*br.getAddress(0x908); 
		 br.rA=2;
		 br.rB=0;
		 
		 // questi sono vuoti
		  br.rC=0;
		  br.immediate=0;
		  br.setType(0x1E);
		  br.yetexec=false; */
		this.brecord.add(br);
		i++;
		return i;
	}
	
	/** Inserisce tutti i break dati come vettore
	 * @param list_break		vettore del BranchRecord da esaminare
	 * @return
	 */
	public int exploreBreak(BranchRecord[] list_break) {
		
		int num=0;
		
		this.brecord.clear(); // cancello tutto
		// li accodo tutti in brecord	
		for(num=0;num<list_break.length;num++)
			this.brecord.add(list_break[num]);
		// restituisco il num di elementi
		return num;
		
	}
	
	/** Aggiunge in coda un branch da monitorare
	 * @param b		BranchRecord da aggiungere
	 */
	public void addBreak(BranchRecord b) {
		this.brecord.add(b);
		
	}
	
	/** Setta tutti i breakpoint trovati
	 * @param t32
	 * @throws Trace32Exception
	 */
	private void setAllBreakPoint() throws Trace32Exception {
		
		// prima cancello tutti i breakpoint
		// forse sarebbe meglio solo disabilitarli
		// oppure registrarseli da qualche parte
		// poi quando si finisce li si rimette
		// come erano
		Tracer.t32.command("break.disable /All");
		Tracer.t32.command("trace.reset");
		//devo mettere un break ancTracer.t32sullo start_line
		Tracer.t32.command("break.set "+Long.toHexString(this.start_address));
		
		
		for(int i=0;i<=(this.n_break-1);i++) {
			BranchRecord4NiosII temp=new BranchRecord4NiosII();
			temp=(BranchRecord4NiosII) this.brecord.get(i);
			long addr=temp.address(); // indirizzo a cui sta il break
			Tracer.t32.command("break.set "+Long.toHexString(addr));
		}
		// devo mettere un break anche sullo end_line
		Tracer.t32.command("break.set "+Long.toHexString(this.end_address));
		
	}
	
	/** Cancella tutti i breakpoint trovati
	 * @param Tracer.t32
	 * @throws Trace32Exception
	 */
	private void delAllBreakPoint() throws Trace32Exception {
		
		// cancello tutti i breakpoint che ho messo
		
		//devo togliere un break anche sullo start_line
		Tracer.t32.command("break.delete "+Long.toHexString(this.start_address));
		
		for(int i=0;i<=(this.n_break-1);i++) {
			BranchRecord4NiosII temp=new BranchRecord4NiosII();
			temp=(BranchRecord4NiosII) this.brecord.get(i);
			long addr=temp.address(); // indirizzo a cui sta il break
			Tracer.t32.command("break.delete "+Long.toHexString(addr));
		}
		// devo togliere un break anche sullo end_line
		Tracer.t32.command("break.delete "+Long.toHexString(this.end_address));
		
		// rimetto tutto a posto com'era
		Tracer.t32.command("break.enable /All");
	}
	
	
	/** Costruttore
	 * @param start_line		indirizzo di partenZA
	 * @param end_line		indirizzo finale
	 * @throws Trace32Exception 
	 * @throws IOException 
	 */
	public TestCase(long start, long end ) throws Trace32Exception, IOException {
		
		this.start_address=start;
		this.end_address=end;
		this.brecord=new Vector();
		
		this.n_break=exploreBreak(); // conta quanti break ci sono
		
		// e riempie i campi
		this.condition=new Conditions(this.n_break);
		
		
		int max=(int) Math.pow(2,this.n_break);
		this.resu=new TraceResult[max];
		
		long[] add=new long[this.n_break]; // array che contiene tutti gli indirizzi dei break
		String[] str_cond=new String[this.n_break]; // contiene tutte le stringhe delle condizioni
		long[] line=new long[this.n_break];// contiene tutte le linee delle condizioni
		String[] filename=new String[this.n_break];// contiene tutti i nomi dei file delle condizioni
		//riempio il campo addr dell'array resu
		for(int k=0;k<=(this.n_break-1);k++) {
			BranchRecord4NiosII br=new BranchRecord4NiosII();
			br=(BranchRecord4NiosII) this.brecord.get(k);
			add[k]=br.address();
			// trovo la stringa della condizione
			str_cond[k]=new String("");
			
			// trovo la linea del file
			line[k]=Tracer.t32.getSourceLine(add[k]);
			
			filename[k]=new String(Tracer.t32.getSourceFile(add[k]));
			
		}
		
		trovaCondizioni(str_cond, line, filename );
		
		for(int j=0;j<=(max-1);j++) {
			this.resu[j]=new TraceResult(this.n_break);
			this.resu[j].setAddr(add);
			this.resu[j].setFile_name(filename);
			this.resu[j].setStr_cond(str_cond);
			this.resu[j].setLine_cond(line);
		}
		
		
		
	}
	
	
	private void trovaCondizioni(String[] str_cond, long[] line, String[] filename) throws IOException {
		String linea="";
		for(int i=0;i<str_cond.length;i++) {
			// apro il file
			File f= new File(filename[i]);
			BufferedReader srcfile=new BufferedReader(new FileReader(f));
			// lo scorro fino a trovare la linea giusta
			for(int j=0;j<line[i];j++)
				linea=srcfile.readLine();
			// chiudo il file
			srcfile.close();
			// trovo inizio e fine della condizione
			int inizio=linea.indexOf("(");
			int fine=linea.lastIndexOf(")");
			str_cond[i]=new String(linea.substring(inizio, fine+1));
			
		}
		
		
	}

	/** Effettua un test con le condizioni date da cond[]
	 * @return	tempo necessario all'esecuzione
	 * 			(-1) se e' un ciclo infinito
	 * @throws Trace32Exception
	 */
	public long testWithThisCond() throws Trace32Exception {
		// in cond ci sono le condizioni attuali
		// cond[i] diche se al breakpoint i
		// si debba o non si debba saltare
		long time_click=-1;
		long start_timestamp;
		long stop_timestamp;
		int curr_addr=0;
		boolean ciclo=false;
		boolean fine=false;
		
		// setto i breakpoint ai posti giusti
		
		this.setAllBreakPoint();
		
		// faccio partire
		Tracer.t32.go();
		// e si ferma allo start_line
		Tracer.t32.Step();
		ARecordOnLine rec_start=new ARecordOnLine(-1);
		//	ora posso cancellare il trace buffer
		Tracer.t32.command("trace.reset");
		// mi segno il timestamp di partenza
		start_timestamp=rec_start.getTimestamp();
		
		
		
		while (!ciclo) {
			Tracer.t32.go(); // si ferma al primo break che incontra
			
			curr_addr=Tracer.t32.readPC(); // leggo l'indirizzo attuale
			if (curr_addr>=this.end_address) { // se sono arrivato ala fine
				fine = true;
				break;						 // esco dal while e termino
			}
			
			// cerco il BranchRecord corrispondente
			// sia esso curr_break e i il suo indice
			// curr_break e' un puntatore
			// quindi modificando quello che punta
			// si modifica quello nella lista
			int i=0;
			BranchRecord4NiosII curr_break=new BranchRecord4NiosII();
			
			for(i=0;i<=this.brecord.size()-1;i++) {
				curr_break=(BranchRecord4NiosII) this.brecord.get(i);
				if ( (curr_break.address()==curr_addr) && (!curr_break.getYetExec()) ){
					//System.out.println("Ho trovato il brecord corrispondente "+i+" 0x"+Integer.toHexString(curr_break.address));
					curr_break.setYetExec(true);
					fine=false;
					break;
				}
			}
			
			// questo per assicurarmi che agisca solo
			// sui break individuati e che sono
			// registrati nel Vector brecord
			if (i==(this.brecord.size())) {
				// allora non ho trovato niente
				// li ho gia' visitati tutti
				// => ciclo
				ciclo=true;
			}
			if ( (!ciclo) && (!fine)) {
				boolean[] cond=new boolean[this.n_break];
				cond=condition.value();
				curr_break.jump(cond[i]);
			}
			
		} //while
		if (fine) {
			Tracer.t32.Step();
			//	prendo il primo record (corrispondente a quello di arrivo)
			ARecordOnLine rec_end=new ARecordOnLine(-1);
			//ora posso cancellare il trace buffer
			Tracer.t32.command("trace.reset");
			// mi segno il timestamp di partenza
			stop_timestamp=rec_end.getTimestamp();
			time_click=stop_timestamp-start_timestamp;
		}
		if( ciclo) {
			// sono finito in un ciclo infinito
			time_click=-1;
		}
		
		// rimetto tutto a posto come era prima
		this.delAllBreakPoint();
		// ritorno il tempo trascorso
		return time_click;
	}  //method
	
	
	/** Effettua i test con tutte le condizioni possibili
	 * @throws Trace32Exception
	 */
	public void tryTest() throws Trace32Exception {
		
		boolean[] b=new boolean[this.n_break];
		int max=(int) Math.pow(2,this.n_break);
		//long[] l=new long[this.n_break];
		
		for(int i=1;i<=max;i++,this.condition.next(b)) {
			b=this.condition.value();
			
			long tim=this.testWithThisCond();
			this.resu[i-1].setTime(tim);
			this.resu[i-1].setCond(b);
			
		}
		
	}
	
	public void printReport() throws Trace32Exception {
		
		System.out.println("***** REPORT SUL TEST DI UN BLOCCO *****");
		System.out.println("START ADDRESS: 0x"+Long.toHexString(this.start_address));
		System.out.println("END ADDRESS: 0x"+Long.toHexString(this.end_address));
		System.out.println("N. DI BREAK CONDIZIONALI TROVATI :"+this.n_break+"\n");
		System.out.println("INDIRIZZI DEI BREAK CONDIZIONALI:");
		for(int j=0;j<this.brecord.size();j++) {
			BranchRecord4NiosII b;
			b=(BranchRecord4NiosII) this.brecord.get(j);
			System.out.println("0x"+Long.toHexString(b.address()));
		}
		System.out.println();
		System.out.println("CONDIZIONI:");
		for(int k=0;k<this.brecord.size();k++) {
			
			/*BranchRecord4NiosII br;
			br=(BranchRecord4NiosII) this.brecord.get(k);*/
			
			System.out.print("b["+k+"]= ");
			
			// prendi la linea e isola la condizione e mettila in line
			System.out.print(this.resu[k].getStr_cond(k));
			System.out.print("\t(linea ");
			long n_linea=this.resu[k].getLine_cond(k);
			System.out.print(n_linea+" in ");
			String file_name=this.resu[k].getFile_name(k);
			System.out.println(file_name+" )");
			
		}
		System.out.println();
		
		for(int i=1;i<=this.resu.length;i++) {
			System.out.println("=== TEST N. "+i+"===============");
			System.out.print("CONDIZIONI IMPOSTE: ");
			boolean[] b=new boolean[this.n_break];
			this.resu[i-1].getCond(b);
			for(int j=0;j<=(this.n_break-1);j++)
				System.out.print(b[j]+" ");
			System.out.println("");
			System.out.print("TEMPO STIMATO: ");
			if (this.resu[i-1].getTime()==-1)
				System.out.println(" LOOP INFINITO!");
			else
				System.out.println(""+this.resu[i-1].getTime()+" cicli");
			System.out.println("============================");
		}
		System.out.println("***** FINE TEST ********************");
		
	}
	
	
}
