package testcase;
//questo per il momento non serve al progetto
//non considerare ai fini della tesi

/** Rappresenta i risultati da un test case
 * @author Pierfrancesco
 *
 */
public class TraceResult {
	
	
	private long time;		// tempo impiegato
	private boolean[] con; 	// condizioni imposte
	private long[] braddr; 	// indirizzi dei break settati
							// (o indirizzi dei branch)
	private String str_cond[];// stringhe che rappresentano la condizione settata
	private long line_cond[];	// num di linea alla quale c'e' la condizione settata
	private String file_name[]; // nome del file nel quale e' presente la condizione da settare
	
	/** Costruttore
	 * @param time	tempo impiegato
	 * @param con	condizioni imposte
	 */
	public TraceResult(long time, boolean[] con ) {
		this.time = time;
		this.con = new boolean[con.length];
		System.arraycopy(con,0,this.con,0,con.length);
		this.braddr=new long[con.length];
		
		this.str_cond=new String[con.length];
		this.line_cond=new long[con.length];
		this.file_name=new String[con.length];
	}
	
	/**Costruttore
	 * @param n		numero di branch
	 */
	public TraceResult(int n) {
		this.con = new boolean[n];	
		this.braddr= new long[n];
		
		this.str_cond=new String[n];
		this.line_cond=new long[n];
		this.file_name=new String[n];
		
	}
	
	
	/** Setta il tempo impiegato
	 * @param t
	 */
	
	public void setTime(long t) { this.time=t; }
	
	/** Legge il tempo impiegato
	 * @return	il tempo impiegato
	 */
	public long getTime() { return this.time; }
	
	/**
	 * @return Returns the file_name.
	 */
	public String getFile_name(int i) {
		return this.file_name[i];
	}

	/**
	 * @param file_name The file_name to set.
	 */
	public void setFile_name(int i, String file_name) {
		this.file_name[i] = new String(file_name);
	}

	/**
	 * @return Returns the line_cond.
	 */
	public long getLine_cond(int i) {
		return line_cond[i];
	}

	/**
	 * @param line_cond The line_cond to set.
	 */
	public void setLine_cond(int i, long line_cond) {
		this.line_cond[i] =(line_cond);
	}

	/**
	 * @return Returns the str_cond.
	 */
	public String getStr_cond(int i) {
		return str_cond[i];
	}

	/**
	 * @param str_cond The str_cond to set.
	 */
	public void setStr_cond(int i, String str_cond) {
		this.str_cond[i] = str_cond;
	}

	/** Setta le condizioni
	 * @param b	vettore delle condizioni
	 */
	public void setCond(boolean[] b) {
		this.con = new boolean[b.length];
		System.arraycopy(b,0,this.con,0,b.length);
	}
	
	/**Legge il vettore delle condizioni
	 * @param b		vettore delle condizioni
	 */
	public void getCond(boolean[] b) {
		
		System.arraycopy(this.con,0,b,0,this.con.length);
	}
	
	/**Setta l'indirizzo del branch
	 * @param l			indirizzo del branch
	 */
	public void setAddr(long[] l) {
		//this.braddr=new long[l.length];
		System.arraycopy(l,0,this.braddr,0,l.length);
	}
	
	/**Legge l'indirizzo del branch
	 * @param l 		indirizzo del branch
	 */
	public void getAddr(long[] l) {
		System.arraycopy(this.braddr,0,l,0,this.braddr.length);
		
	}



	/**
	 * @param file_name The file_name to set.
	 */
	public void setFile_name(String[] file_name) {
		System.arraycopy(file_name,0,this.file_name,0,file_name.length);
		
	}

	

	/**
	 * @param line_cond The line_cond to set.
	 */
	public void setLine_cond(long[] line_cond) {
		System.arraycopy(line_cond,0,this.line_cond,0,line_cond.length);
	}

	

	/**
	 * @param str_cond The str_cond to set.
	 */
	public void setStr_cond(String[] str_cond) {
		System.arraycopy(str_cond,0,this.str_cond,0,str_cond.length);
	}
	
	
	
	
}
